/*+
|                                               |
|     Trigger: DTULTATU_OPERTIPOSUPRI           |  
|     Tabela : OPERTIPOSUPRI                    |
|                                               |
|     Criao:                                  |
|     31/03/2009 - Leonardo Bispo               |
|                                               |
+*/


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_OPERTIPOSUPRI' and
            type = 'TR'                       and
            u.uid = o.uid                     and
            u.name = USER)
   DROP TRIGGER DTULTATU_OPERTIPOSUPRI
GO

CREATE TRIGGER DTULTATU_OPERTIPOSUPRI
ON OPERTIPOSUPRI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
         (SELECT 'OPERTIPOSUPRI',
                 'CDTIPOSUPRI='+CDTIPOSUPRI + ';CDOPERADOR='+CDOPERADOR+';',
                  GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE OPERTIPOSUPRI
      SET DTULTATUOPTPSUP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(OPERTIPOSUPRI.CDTIPOSUPRI, 0) = ISNULL(INSERTED.CDTIPOSUPRI, 0)) AND
            (ISNULL(OPERTIPOSUPRI.CDOPERADOR, 0)  = ISNULL(INSERTED.CDOPERADOR, 0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_OPERTIPOSUPRI','5.07.015';
GO

